module Parsing.SrcLoc where

data SrcLoc = SrcLoc {
	line :: Int,
	char :: Int
	}
	deriving (Eq)

instance Show SrcLoc where
	show (SrcLoc i j) = "(" ++ show i ++ "," ++ show j ++ ")"

shift :: SrcLoc -> Int -> SrcLoc
shift loc nbChars = loc {
	char = char loc + nbChars
	}


instance Ord SrcLoc where
	(SrcLoc i j) <= (SrcLoc i' j') = i < i' || (i == i' && j <= j')


type Stream     = (SrcLoc, String)


consume :: String -> Stream -> Stream
consume string (loc, str) = (loc `shift` (length string), drop (length string) str)

loc (l,s) = l

str (l,s) = s

furthest x y = if (loc y) > (loc x)
	then y
	else x

